<?php 
/**
 * Plugin Name: CTT for WooCommerce
 * Description: CTT for WooCommerce
 * Version: 3.1.87
 * Author: CTT
 * Author URI: https://ctt.pt
 * Text Domain: CTT-for-woocommerce
 * @package CTT
 *
 * Woo: 12345:342928dfsfhsf8429842374wdf4234sfd
 * WC requires at least: 3.0.0
 * WC tested up to: 5.5.0
 * 
 */

if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly.
}

$plugin_url = plugin_dir_url( __FILE__ ); 
# Get rid of the protocol entirely 
$plugin_url = preg_replace('/https?\:/', '', $plugin_url );  

define( 'CTT_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );
define( 'CTT_PLUGIN_FILE',  __FILE__ );
define( 'CTT_PLUGIN_URL',  $plugin_url );
define( 'CTT_LOGO', CTT_PLUGIN_URL.'assets/images/logo.svg'); 
 
require_once(CTT_PLUGIN_PATH .'/constants.php'); 
require_once(CTT_PLUGIN_PATH .'includes/class-woo-CTT.php');


add_action(
    'before_woocommerce_init',
    function() {
        // Check if the FeaturesUtil class exists in the \Automattic\WooCommerce\Utilities namespace.
        if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
            // Declare compatibility with custom order tables using the FeaturesUtil class.
            \Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables', __FILE__, true );
        }
    }
);


/** 
 * Marketplace have special needs, vendors have their own keys and the owner of the site might not 
 * have a contract with CTT 
 * @return true if a marketplace we integrate with is installed 
 */ 
function CTT_is_marketplace() {
  global $CTT_wcfm, $CTT_dokan;
  return isset($CTT_wcfm) || isset($CTT_dokan); 
} 

$CTT = WooCTT::instance(); 
$CTT->bootstrap();  