<?php 
/**  
 * print a single field in the form 
 * try to get the value from the vendor object 
 */ 
function CTT_account_print_field ( $label, $name , $vendor ) { 
?>
    <div class='form-item'>
        <label><?php echo $label ?></label>
        <input type='text' name='<?php echo $name?>' value="<?php echo isset($vendor->$name) ? $vendor->$name : ''?>"/>
    </div>
<?php     
}

/** 
 *  Object Vendor containing all fields we can pre-fill from market place info 
 */ 
function CTT_account_print_form($vendor, $error, $message) {
    $CTT = WooCTT::instance(); 
    get_header();  

    echo "<h2> " . $CTT->translate("requestaccount") . " </h2> "; 

    if($message){
        echo "$message<br/>"; 
    }

    if($message && !$error){
        die(); 
    }

    echo "<form class='CTT-request-account' action='" . get_site_url() . "/CTT-request-account?vendor_id=" . $vendor->userid . "' method='POST'>"; 
     
    CTT_account_print_field( $CTT->translate('companyname'), 'companyname',$vendor ); 
    CTT_account_print_field( $CTT->translate('contactperson'),'name', $vendor );  
    CTT_account_print_field( $CTT->translate('contactphone'),'phone',$vendor ); 
    CTT_account_print_field( $CTT->translate('fiscal'),'fiscal',$vendor ); 
    CTT_account_print_field("Email", 'email', $vendor ); 

    echo "<br/><br/><h2>Shipping information</h2>"; 
    CTT_account_print_field($CTT->translate('streetname'),'streetname', $vendor );

    CTT_account_print_field( $CTT->translate("zipcode"),'zipcode', $vendor );
    CTT_account_print_field( $CTT->translate('city'), 'city',$vendor ); 
    CTT_account_print_field( $CTT->translate('province'), 'province',$vendor ); 
    CTT_account_print_field( $CTT->translate('country'), 'country',$vendor );
    echo "<br/><br/><button type='submit'>" . $CTT->translate('submitrequest') . "</button>"; 
    echo "</form>";
}